jobd.pl: change --max-parallel default and add docs
[girocco.git] / jobd / gc.sh
blobb6b874245b70ebc5e1b3ea36a53ceaea8e6e7b3f
1 #!/bin/sh
3 # NOTE: additional options can be passed to git repack by specifying
4 # them after the project name, for example:
5 # gc.sh my-project -f
7 . @basedir@/shlib.sh
9 set -e
11 if [ $# -lt 1 ]; then
12 echo "Usage: gc.sh projname [extra-repack-args]" >&2
13 exit 1
16 # packing options
17 packopts="--depth=50 --window=50 --window-memory=${var_window_memory:-1g}"
19 umask 002
20 [ "$cfg_permission_control" != "Hooks" ] || umask 000
22 pidactive() {
23 if _result="$(kill -0 "$1" 2>&1)"; then
24 # process exists and we have permission to signal it
25 return 0
27 case "$_result" in *"not permitted"*)
28 # we do not have permission to signal the process
29 return 0
30 esac
31 # process does not exist
32 return 1
35 createlock() {
36 # A .lock file should only exist for much less than a second.
37 # If we see a stale lock file (> 1h old), remove it and then,
38 # just in case, wait 30 seconds for any process whose .lock
39 # we might have just removed (it's racy) to finish doing what
40 # should take much less than a second to do.
41 _stalelock="$(find "$1.lock" -maxdepth 1 -mmin +60 -print 2>/dev/null || :)"
42 if [ -n "$_stalelock" ]; then
43 rm -f "$_stalelock"
44 sleep 30
46 for _try in p p n; do
47 if (set -C; > "$1.lock") 2>/dev/null; then
48 echo "$1.lock"
49 return 0
51 # delay and try again
52 [ "$_try" != "p" ] || sleep 1
53 done
54 # cannot create lock file
55 return 1
58 # return true if there's more than one objects/pack-<sha>.pack file or
59 # ANY sha-1 files in objects
60 is_dirty() {
61 _packs=$(find objects/pack -type f -name "pack-$octet20.pack" -print | wc -l)
62 if [ $_packs != 1 ] && [ $_packs != 0 ]; then
63 return 0
65 _objs=$(find objects/$octet -type f -name "$octet19" -print 2>/dev/null | wc -l)
66 [ $_objs -ne 0 ]
69 # if the current directory is_gfi_mirror then repack all packs listed in gfi-packs
70 repack_gfi_packs() {
71 is_gfi_mirror || return 0
72 [ -s gfi-packs ] || return 0
73 while IFS=': ' read -r _pack _junk; do
74 if [ -s "$_pack" -a -s "${_pack%.pack}.idx" ]; then
75 git show-index < "${_pack%.pack}.idx" | cut -d ' ' -f 2
77 done < gfi-packs | \
78 git pack-objects $packopts --no-reuse-delta --delta-base-offset \
79 --non-empty $quiet objects/pack/packtmp | \
80 while read -r _newpack; do
81 rm -f objects/pack/pack-$_newpack.*
82 ln -f objects/pack/packtmp-$_newpack.pack objects/pack/pack-$_newpack.pack
83 ln -f objects/pack/packtmp-$_newpack.idx objects/pack/pack-$_newpack.idx
84 rm -f objects/pack/packtmp-$_newpack.*
85 done
86 rm -f gfi-packs
89 # HEADSHA="$(pack_is_complete /full/path/to/some.pack /full/path/to/packed-refs "$(cat HEAD)")"
90 pack_is_complete() {
91 # Must have a matching .idx file and a non-empty packed-refs file
92 [ -s "${1%.pack}.idx" ] || return 1
93 [ -s "$2" ] || return 1
94 _headsha=
95 case "$3" in
96 $octet20)
97 _headsha="$3"
99 "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
100 _headmatch="${3#ref:}"
101 _headmatch="${_headmatch# }"
102 _headmatchpat="$(echo "$_headmatch" | sed -e 's/\([.$]\)/\\\1/g')"
103 _headsha="$(grep -e "^$octet20 $_headmatchpat\$" < "$2" | \
104 cut -d ' ' -f 1)"
105 case "$_headsha" in $octet20) :;; *)
106 return 1
107 esac
110 # bad HEAD
111 return 1
112 esac
113 rm -rf pack_is_complete_test
114 mkdir pack_is_complete_test
115 mkdir pack_is_complete_test/refs
116 mkdir pack_is_complete_test/objects
117 mkdir pack_is_complete_test/objects/pack
118 echo "$_headsha" > pack_is_complete_test/HEAD
119 ln -s "$1" pack_is_complete_test/objects/pack/
120 ln -s "${1%.pack}.idx" pack_is_complete_test/objects/pack/
121 ln -s "$2" pack_is_complete_test/packed-refs
122 _count="$(git --git-dir=pack_is_complete_test rev-list --count --all 2>/dev/null || :)"
123 rm -rf pack_is_complete_test
124 [ -n "$_count" ] || return 1
125 [ "$_count" -gt 0 ] 2>/dev/null || return 1
126 echo "$_headsha"
129 proj="${1%.git}"
130 shift
131 cd "$cfg_reporoot/$proj.git"
133 trap 'if [ $? != 0 ]; then echo "gc failed dir: $PWD" >&2; fi' EXIT
134 trap 'exit 130' INT
135 trap 'exit 143' TERM
137 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
138 datefmt='+%a, %d %b %Y %T %z'
140 if check_interval lastgc $cfg_min_gc_interval; then
141 progress "= [$proj] garbage check skip (last at $(config_get lastgc))"
142 exit 0
144 if [ -e .nogc ]; then
145 progress "x [$proj] garbage check disabled"
146 exit 0
149 # Avoid unnecessary garbage collections:
150 # 1. If lastreceive is set and is older than lastgc
151 # -AND-
152 # 2. We are not a fork (! -s alternates) -OR- lastparentgc is older than lastgc
154 # If lastgc is NOT set or lastreceive is NOT set we MUST run gc
155 # If we are a fork and lastparentgc is NOT set we MUST run gc
157 # If the repo is dirty after removing any crud we MUST run gc
159 gcstart="$(date "$datefmt")"
160 skipgc=
161 isfork=
162 [ -s objects/info/alternates ] && isfork=1
163 lastparentgcsecs=
164 [ -n "$isfork" ] && lastparentgcsecs="$(config_get_date_seconds lastparentgc || :)"
165 lastreceivesecs=
166 if lastreceivesecs="$(config_get_date_seconds lastreceive)" && \
167 lastgcsecs="$(config_get_date_seconds lastgc)" && \
168 [ $lastreceivesecs -lt $lastgcsecs ]; then
169 # We've run gc since we last received, so maybe we can skip,
170 # check if not fork or fork and lastparentgc < lastgc
171 if [ -n "$isfork" ]; then
172 if [ -n "$lastparentgcsecs" ] && \
173 [ $lastparentgcsecs -lt $lastgcsecs ]; then
174 # We've run gc since our parent ran gc so we can skip
175 skipgc=1
177 else
178 # We don't have any alternates (we're not a forK) so we can skip
179 skipgc=1
183 # be compatibile with gc.pid file from newer Git releases
185 hn="$(hostname)"
186 lockf=gc.pid
187 active=
188 if [ "$(createlock "$lockf")" ]; then
189 # If $lockf is:
190 # 1) less than 12 hours old
191 # 2) contains two fields (pid hostname) NO trailing NL
192 # 3) the hostname is different OR the pid is still alive
193 # then we exit as another active process is holding the lock
194 if [ "$(find "$lockf" -maxdepth 1 -mmin -720 -print 2>/dev/null)" ]; then
195 apid=
196 ahost=
197 read -r apid ahost ajunk < "$lockf" || :
198 if [ "$apid" ] && [ "$ahost" ]; then
199 if [ "$ahost" != "$hn" ] || pidactive "$apid"; then
200 active=1
204 else
205 echo >&2 "[$proj] unable to create gc.pid.lock file"
206 exit 1
208 if [ -n "$active" ]; then
209 rm -f "$lockf.lock"
210 echo >&2 "[$proj] gc already running on machine '$ahost' pid '$apid'"
211 exit 1
213 printf "%s %s" "$$" "$hn" > "$lockf.lock"
214 chmod 0664 "$lockf.lock"
215 mv -f "$lockf.lock" "$lockf"
217 # Remove any existing FETCH_HEAD
218 # There can only be a FETCH_HEAD if we've been fetching, not if we've been
219 # receiving pushes (those never create a FETCH_HEAD).
220 # And if we're fetching because we're a mirror, we know we're not fetching right
221 # now since jobd.pl never runs a project's fetch simultaneously with its gc.
222 # Therefore any existing FETCH_HEAD is junk. And it may be many megabytes if
223 # there were a lot of refs.
224 rm -f FETCH_HEAD
226 # Remove any stale pack remnants that are more than an hour old.
227 # Stale pack fragments are defined as any pack-<sha1>.ext where .ext is NOT
228 # .pack AND the corresponding .pack DOES NOT exist. A bunch of stale
229 # pack-<sha1>.idx files without their corresponding .pack files are worthless
230 # and just waste space. Normally there shouldn't be any remnants but actually
231 # this can happen when things are interrupted at just the wrong time.
232 # Note that the objects/pack directory is created by git init and should
233 # always exist.
234 find objects/pack -maxdepth 1 -type f -mmin +60 -name "pack-$octet20.?*" -print | \
235 sed -e 's/^objects\/pack\/pack-//; s/\..*$//' | LC_ALL=C sort -u | \
236 while read packsha; do
237 [ ! -e "objects/pack/pack-$packsha.pack" ] || continue
238 rm -f "objects/pack/pack-$packsha".?*
239 done
241 # Remove any stale pack .keep files that are more than 12 hours old.
242 # We don't do anything to create any permanent pack .keep files, so they must
243 # be remnants from some failed push or something. Removing the .keep will
244 # allow the pack to be properly repacked.
245 find objects/pack -maxdepth 1 -type f -mmin +720 -name "pack-$octet20.keep" -print0 | xargs -0 rm -f
247 # Remove any stale tmp_pack_* or tmp_idx_* or tmp_bitmap_* or packtmp-* files
248 # that are more than 12 hours old.
249 find objects/pack -maxdepth 1 -type f -mmin +720 -name "tmp_pack_?*" -print0 | xargs -0 rm -f
250 find objects/pack -maxdepth 1 -type f -mmin +720 -name "tmp_idx_?*" -print0 | xargs -0 rm -f
251 find objects/pack -maxdepth 1 -type f -mmin +720 -name "tmp_bitmap_?*" -print0 | xargs -0 rm -f
252 find objects/pack -maxdepth 1 -type f -mmin +720 -name "packtmp-?*" -print0 | xargs -0 rm -f
254 # Remove any stale shallow_* files that are more than 12 hours old.
255 # These can be left behind by Git >= 1.8.4.2 and < 2.0.0 when a client
256 # requests a shallow clone.
257 find . -maxdepth 1 -type f -mmin +720 -name "shallow_?*" -print0 | xargs -0 rm -f
259 # Remove any stale *.temp files in the objects area that are more than 12 hours old.
260 # This can be stale sha1.temp, or stale *.pack.temp so we kill all stale *.temp.
261 find objects -type f -mmin +720 -name "*.temp" -print0 | xargs -0 rm -f
263 # Remove any stale *.lock files in the htmlcache area that might have been left
264 # behind after an abnormal exit during an attempt to update a cached file and
265 # are more than 1 hour old.
266 ! [ -d htmlcache ] || find htmlcache -type f -mmin +60 -name "*.lock" -print0 | xargs -0 rm -f
268 # Remove any stale git-svn temp files that are more than 12 hours old.
269 # The git-svn process creates temp files with random 10 character names
270 # in the root of $GIT_DIR. Unfortunately they do not have a recognizable
271 # prefix, so we just have to kill any files with a 10-character name. We
272 # do this only for git-svn mirrors. All characters are chosen from
273 # [A-Za-z0-9_] so we can at least check that and fortunately the only
274 # collision is 'FETCH_HEAD' but that shouldn't matter.
275 # There may also be temp files with a Git_ prefix as well.
276 if is_svn_mirror; then
277 _randchar='[A-Za-z0-9_]'
278 _randchar2="$_randchar$_randchar"
279 _randchar4="$_randchar2$_randchar2"
280 _randchar10="$_randchar4$_randchar4$_randchar2"
281 find . -maxdepth 1 -type f -mmin +720 -name "$_randchar10" -print0 | xargs -0 rm -f
282 find . -maxdepth 1 -type f -mmin +720 -name "Git_*" -print0 | xargs -0 rm -f
285 # Remove any stale fast_import_crash_<pid> files that are more than 3 days old.
286 if is_gfi_mirror; then
287 find . -maxdepth 1 -type f -mmin +4320 -name "fast_import_crash_?*" -print0 | xargs -0 rm -f
290 # Do not skip gc if the repo is dirty
291 if [ -n "$skipgc" ] && ! is_dirty; then
292 progress "= [$proj] garbage check nothing but crud removal to do (`date`)"
293 config_set lastgc "$gcstart"
294 rm -f "$lockf"
295 exit 0
298 bumptime=
299 if [ -n "$isfork" ] && [ -z "$lastparentgcsecs" ]; then
300 # set lastparentgc and then update gcstart to be at least 1 second later
301 config_set lastparentgc "$gcstart"
302 bumptime=1
304 if [ -z "$lastreceivesecs" ]; then
305 # set lastreceive and then update gcstart to be at least 1 second later
306 config_set lastreceive "$gcstart"
307 bumptime=1
309 if [ -n "$bumptime" ]; then
310 sleep 1
311 gcstart="$(date "$datefmt")"
314 progress "+ [$proj] garbage check (`date`)"
316 # safe pruning: we put all our objects in all forks, then we can
317 # safely get rid of extra ones; repacks in forks will get rid of
318 # the redundant ones again then
319 forkdir="$proj"
320 if [ -d "../${forkdir##*/}" ]; then
321 # It is enough to copy objects just one level down and get_repo_list
322 # takes a regular expression (which is automatically prefixed with '^')
323 # so we can easily match forks exactly one level down from this project
324 get_repo_list "$forkdir/[^/]*:" |
325 while read fork; do
326 # Ignore forks that do not exist or are symbolic links
327 [ ! -L "$cfg_reporoot/$fork.git" -a -d "$cfg_reporoot/$fork.git" ] || \
328 continue
329 # Or do not have a non-zero length alternates file
330 [ -s "$cfg_reporoot/$fork.git/objects/info/alternates" ] || \
331 continue
332 # Match objects in parent project
333 for d in objects/?? objects/pack; do
334 [ "$d" != "objects/??" ] || continue
335 mkdir -p "$cfg_reporoot/$fork.git/$d"
336 [ "$d" != "objects/pack" ] || \
337 [ "$(echo objects/pack/*)" != \
338 "objects/pack/*" ] || \
339 continue
340 ln -f "$d"/* "$cfg_reporoot/$fork.git/$d" || :
341 done
342 # Update the fork's lastparentgc date (must be current, not $gcstart)
343 GIT_DIR="$cfg_reporoot/$fork.git" git config \
344 gitweb.lastparentgc "$(date "$datefmt")"
345 done
348 quiet=; [ -n "$show_progress" ] || quiet=-q
350 git pack-refs --all
351 repack_gfi_packs
352 rm -f .gcfailed bundles/*
353 rm -f objects/pack/pack-*.bndl
354 # The git repack command may issue a 'disabling bitmap' warning for some
355 # repositories. This is perfectly normal and should be suppressed unless
356 # show_progress is set. Unfortunately that means we have to grep -v the
357 # output. And furthermore, since it's a translated message, we have to
358 # force the language to english to be sure we do it.
359 repackcmd="git repack $packopts -a -d -l $quiet $@"
360 [ -n "$show_progress" ] || \
361 repackcmd="{ LC_ALL=C $repackcmd 2>&1 || touch .gcfailed; } | grep -v 'disabling bitmap' || :"
362 eval "$repackcmd"
363 [ ! -e .gcfailed ] || exit 1
364 allpacks="$(echo objects/pack/pack-$octet20.pack)"
365 curhead="$(cat HEAD)"
366 pkrf=
367 [ ! -e packed-refs ] || pkrf=packed-refs
368 eval "reposizek=$(( $(echo 0 $(du -k $pkrf $allpacks 2>/dev/null | awk '{print $1}') | \
369 sed -e 's/ / + /g') ))"
370 # The git prune command does not take a -q or --quiet but started outputting
371 # 'Checking connectivity' progress messages in v1.7.9. However, we can
372 # suppress those by piping through cat as it only activates the progress
373 # messages when stderr is a tty.
374 prunecmd='git prune'
375 [ -n "$show_progress" ] || \
376 prunecmd="{ $prunecmd 2>&1 || touch .gcfailed; } | cat"
377 eval "$prunecmd"
378 [ ! -e .gcfailed ] || exit 1
379 git update-server-info
381 # darcs:// mirrors have a xxx.log file that will grow endlessly
382 # if this is a mirror and the file exists, shorten it to 10000 lines
383 # also take this opportunity to optimize the darcs repo
384 if [ ! -e .nofetch ] && [ -n "$cfg_mirror" ]; then
385 url="$(config_get baseurl || :)"
386 case "$url" in darcs://*)
387 if [ -n "$cfg_mirror_darcs" ]; then
388 url="${url%/}"
389 basedarcs="$(basename "${url#darcs:/}")"
390 if [ -f "$basedarcs.log" ]; then
391 tail -n 10000 "$basedarcs.log" > "$basedarcs.log.$$"
392 mv -f "$basedarcs.log.$$" "$basedarcs.log"
394 if [ -d "$basedarcs.darcs" ]; then
396 cd "$basedarcs.darcs"
397 # Note that this does not optimize _darcs/inventories/ :(
398 darcs optimize
402 esac
405 # Create a matching .bndl header file for the all-in-one pack we just created
406 # but only if we're not a fork (otherwise the bundle would not be complete)
407 # and we are running at least Git version 1.7.2 (pack_is_complete always fails otherwise)
408 if [ ! -s objects/info/alternates ] && [ -n "$var_have_git_172" ]; then
409 # There should only be one pack in $allpacks but if there was a
410 # simultaneous push...
411 # The one we just created will have a .idx and will NOT have a .keep
412 pkfound=
413 pkhead=
414 for pk in $allpacks; do
415 [ -s "$pk" ] || continue
416 pkbase="${pk%.pack}"
417 [ -s "$pkbase.idx" ] || continue
418 [ ! -e "$pkbase.keep" ] || continue
419 if pkhead="$(pack_is_complete "$PWD/$pk" "$PWD/packed-refs" "$curhead")"; then
420 pkfound="$pkbase"
421 break;
423 done
424 if [ -n "$pkfound" -a -n "$pkhead" ]; then
426 echo "# v2 git bundle"
427 sed -ne "/^$octet20 refs\/[^ $tab]*\$/ p" < packed-refs
428 echo "$pkhead HEAD"
429 echo ""
430 } > "$pkbase.bndl"
431 bndletag="$("$cfg_basedir/bin/rangecgi" --etag "$pkbase.bndl" "$pkbase.pack" || :)"
432 bndlsha="$(printf '%s' "$bndletag" | git hash-object --stdin || :)"
433 if [ -n "$bndletag" ]; then
434 case "$bndlsha" in $octet20)
435 bndlshatrailer="${bndlsha#????????}"
436 bndlshaprefix="${bndlsha%$bndlshatrailer}"
437 bndlname="$(TZ=UTC date +%Y%m%d_%H%M%S)-${bndlshaprefix:-0}"
438 [ -d bundles ] || mkdir bundles
439 echo "${pkbase#objects/pack/}.bndl" > "bundles/$bndlname"
440 echo "${pkbase#objects/pack/}.pack" >> "bundles/$bndlname"
441 esac
446 # Record the size of this repo as the sum of its *.pack sizes as 1024-byte blocks
447 config_set_raw girocco.reposizek "${reposizek:-0}"
449 # We use $gcstart here to avoid a race where a push occurs during the gc itself
450 # and the next future gc could be incorrectly skipped if we used the current
451 # timestamp here instead
452 config_set lastgc "$gcstart"
453 rm -f "$lockf"
455 progress "- [$proj] garbage check (`date`)"